import React from 'react';
import LanguageStore from "./../../../stores/LanguageStore";
import DesignStore from "./../../../stores/DesignStore";
import MSButton from "./../../UI/MSButton";

class AppointmentList extends React.Component {

  constructor(props) {
    super(props);

    this.state = {
      appointments: props.list,
      callback: props.callback,
      designs : DesignStore.getDesign()
    };
    this.update = this.update.bind(this);
    this.appointmentClicked = this.appointmentClicked.bind(this)
    this.listAppointments = this.listAppointments.bind(this)
   }

   componentDidMount (){
     DesignStore.on("design_loaded", this.update);
   }

   update(){
     this.setState({
       designs : DesignStore.getDesign()
     })
   }

  appointmentClicked(e, item){
    this.state.callback(item.ap, item.au);
  }

  listAppointments(){
    let buttonStyles = null

    if(this.state.designs){
      buttonStyles = {
        backgroundColor:this.state.designs["main_color"]
      };
    }

    return (
      <div>
        <h2>{LanguageStore.translate("document_scan_list")}</h2>
        <div className="ap_list">
          {this.state.appointments.map(function(item, index){
            return <MSButton name={item.ap.ap_title +" - "+item.ap.ap_time} action={(e) => this.appointmentClicked(e, item)} key={ index } />
          }.bind(this))}
        </div>
      </div>
    )
  }

  render() {
    const list = this.listAppointments();
    return (
      list
    );
  }
}

export default AppointmentList;
