import Keyboard from 'react-simple-keyboard';
import React from 'react';
import axios from 'axios';
import dispatcher from "../../../Dispatcher";
import { properties } from '../../../properties.js';
import AppStore from "./../../../stores/AppStore";
import DesignStore from "../../../stores/DesignStore";
import QrReader from 'react-qr-reader'
import LanguageStore from "./../../../stores/LanguageStore";
import MSButton from "./../../UI/MSButton"
import QRScan from "./../QRScan/QRScan"
import BackButton from "./../../UI/BackButton";
import CheckinStore from "./../../../stores/CheckinStore";

import CheckinProzess from './../QRScan/CheckinProzess'

class Entry extends React.Component {

  constructor(props) {
    super(props);

    this.state = {
      display: AppStore.getDisplay(),
      designs : DesignStore.getDesign(),
      open_action : "",
      pin_input: ""
    }

    this.handleScan = this.handleScan.bind(this);
    this.handleError = this.handleError.bind(this);
    this.hwqr_code_scanned = this.hwqr_code_scanned.bind(this);
    this.clickedPin = this.clickedPin.bind(this);
    this.update = this.update.bind(this);
    this.onChange = this.onChange.bind(this);
    this.handlePin = this.handlePin.bind(this);
    this.reset = this.reset.bind(this);
    this.success = this.success.bind(this);
    this.error = this.error.bind(this);
    this.handleKeyPress = this.handleKeyPress.bind(this);

    this.layout = {
        default: [
          "1 2 3",
          "4 5 6",
          "7 8 9",
          "{bksp} 0 "
        ],
      };

  }

  handleKeyPress = (event) => {
    if(event.key === 'Enter'){
      this.handlePin();
    }

    let input = this.state.pin_input + event.key;
    this.setState({
      pin_input: input
    });
  }

  onChange (input){
  window.globals["resetTimer_reset"]();

   this.setState({
     pin_input: input
   });

 };

  componentDidMount (){
    DesignStore.on("design_loaded", this.update);
  }

  update(){
    this.setState({
      designs : DesignStore.getDesign()
    })
  }

  handleError(){
    console.log("error scan");
  }

  handleScan (data) {

    this.app_event = data;

    if (data) {
      axios.get(properties.api_url + "/door/?code="+data+"&SID=" + properties.key,{code:data})
      .then(this.success).catch(this.error)
    }
  }

  handlePin() {
    this.handleScan (this.state.pin_input)
  }

  hwqr_code_scanned(event){
    event.preventDefault();
    var code = window.$('#hw_qr_code').val();
    this.handleScan(code);
  }

  success(){

    setTimeout(function(){
      window.location.reload();
    }, 1000 * 3);

    this.setState({
      pin_input: "",
      open_action : "success"
    });
  }

  error(){

    axios.get(properties.api_url + "/visitors/?qrcode="+this.app_event+"&SID=" + properties.key,{code:this.app_event})
     .then(res => {
       this.setState({
         ap: res.data.AP,
         au: res.data.AU
       });

     }).catch(function(e){
       this.setState({
         pin_input: "",
         open_action : "error"
       });
     }.bind(this));
  }

  reset(){
    console.log("clicked");
    this.setState({
      pin_input: "",
      open_action : ""
    });
  }

  clickedPin(e){
    this.setState({
      open_action : "PinCode"
    });
  }

  render() {

    this.focusSaver = setInterval(function(){
      window.$("#pin_input").focus();
    }, 100);

    if(this.state.ap){
      setTimeout(function(){window.location.reload()}, 1000);
      return(
        <CheckinProzess ap={this.state.ap} au={this.state.au} />
      )
    }

    if(this.state.open_action === "error"){
      return(
        <div className="main_view" id="entry">
          <h1>Pin-Code ungültig oder außerhalb der berechtigten Zeitzone!</h1>
          <MSButton action={this.reset} name="Zurück" />
        </div>
      );
    }

    if(this.state.open_action === "success"){
      return(
        <div className="main_view" id="entry">
          <h1>Eingabe erfolgreich - Tür öffnet</h1>
        </div>
      );
    }

    if(this.state.open_action === ""){
      return(
        <div className="main_view" id="pincode">
          <h1>Pin-Code Eingabe</h1>
          <input type="password" id="pin_input" value={this.state.pin_input} onKeyPress={this.handleKeyPress} />

            <Keyboard
              physicalKeyboardHighlight={true}
              onChange={ (input) => this.onChange(input)}
              layout={this.layout}
              preventMouseDownDefault={true}
              display={{ '{bksp}': 'löschen' }}
            />

          <MSButton action={this.handlePin} name="OK" />
        </div>
      );
    }

  }
}

export default Entry;
