import React from 'react';
import axios from 'axios';
import dispatcher from "../../../Dispatcher";
import { properties } from '../../../properties.js';
import AppStore from "./../../../stores/AppStore";
import DesignStore from "../../../stores/DesignStore";

class Language extends React.Component {

  constructor(props) {
    super(props);

    this.state = {
      display: AppStore.getDisplay(),
      languages: [],
      designs : DesignStore.getDesign()
    }
  }

  componentDidMount (){
    this.loadLanguages();
    DesignStore.on("design_loaded", this.update);
  }

  update(){
    this.setState({
      designs : DesignStore.getDesign()
    })
  }

  loadLanguages(){
    axios.get(properties.api_url + "/language/?SID=" + properties.key)
    .then(res => {
      this.setState({
        languages: res.data,
        })
      })
  }

  changeLanguage(lang){
    let action = "Main";
    if(this.state.designs){
      action = this.state.designs.after_lang_chossen;
    }

    dispatcher.dispatch({
      type: "load_language",
      data: lang
    })

    dispatcher.dispatch({
      type: "update_action",
      data: action
    })
  }

  render() {
    const langs = this.state.languages.map((lang) =>
      <div key={lang.jdl_country_code} className="language" id={lang.jdl_code} onClick={(e) => this.changeLanguage(lang.jdl_code)} >

        <img src={properties.images_url + "/flags/" + lang.jdl_flag_icon} alt={lang.jdl_country_name} />
      </div>
    );

    return (
      <div id="languages" className="main_view">
        {langs}
      </div>
    );
  }
}

export default Language;
