import React from 'react';
import moment from 'moment';
import CheckinButton from './ui/CheckinButton'
import CheckinProzess from './CheckinProzess'
import CheckoutProzess from './CheckoutProzess'
import CheckoutButton from './ui/CheckoutButton'
import LanguageStore from "./../../../stores/LanguageStore";
import MSButton from "./../../UI/MSButton";
import BackButton from "./../../UI/BackButton";

class Greeting extends React.Component {

  constructor(props){
    super(props)
    this.state ={
      ap : props.ap,
      au : props.au,
    }

    this.checkinBtnAction = this.checkinBtnAction.bind(this);
    this.checkoutBtnAction = this.checkoutBtnAction.bind(this);
    this.back = this.back.bind(this);
  }

  checkinBtnAction(){
    this.setState({
      next : "checkin"
    });
  }

  checkoutBtnAction(){
    this.setState({
      next : "checkout"
    });
  }

  back(){
    let action = window.globals.jump_list;
    window.globals.jump_list = undefined;
    action();
  }

  render() {

    let  statetime = moment.unix(this.state.ap.ap_start_int).format('HH:mm');
    let name =" ";

    this.state.au.au_surname.split(" ").forEach(function(val){
      name += val.charAt(0).toUpperCase() + val.slice(1).toLowerCase() + " "
    });

    this.state.au.au_name.split(" ").forEach(function(val){
      name += val.charAt(0).toUpperCase() + val.slice(1).toLowerCase() + " "
    });

    if(this.state.next === "checkin"){
      return(<CheckinProzess ap={this.state.ap} au={this.state.au} />);
    }else if(this.state.next === "checkout"){
      return(<CheckoutProzess ap={this.state.ap} au={this.state.au} />);
    }

    window.globals.jump_greeting = function(){
      this.setState({
        next: null
      });
    }.bind(this);

    var condition = "";

    if(this.state.au.au_autologin_on_qr === "1") {
       this.checkinBtnAction();
    }else{
      if(this.state.au.au_state === "") {
        condition =(<CheckinButton action={this.checkinBtnAction} />)
      }
      if(this.state.au.au_state === "left") {
        condition =(<CheckinButton action={this.checkinBtnAction} />)
      }
      if(this.state.au.au_state === "onside"){
        condition =(<CheckoutButton action={this.checkoutBtnAction} />)
      }
    }

    return (
      <div id="greeting">
        <h1>{LanguageStore.translate("self_greeting_title")} {LanguageStore.translate(this.state.au.au_title)}
          { name }
        </h1>

        <p>{LanguageStore.translate("self_greeting_title2")}!</p>
        <p>{LanguageStore.translate("checkin_greeting").replace("@time@", statetime.toString() ).replace("@title@", this.state.ap.ap_title )}</p>
        <hr />

        {condition}

        {window.globals.jump_list !== undefined &&
          <BackButton  id="msback" action={this.back} />
        }

      </div>
    );
  }
}

export default Greeting;
