import React from 'react';
import Iframe from 'react-iframe'
import {properties } from '../../../properties.js';
import CheckinStore from "./../../../stores/CheckinStore";
import DesignStore from "./../../../stores/DesignStore";
import LanguageStore from "./../../../stores/LanguageStore";

class Guidance extends React.Component {

  constructor(props){
    super(props)
    this.state ={
      ap : props.checkin.ap,
      au : props.checkin.au,
      checkin : props.checkin,
      selection: null,
      timer : null,
      designs : DesignStore.getDesign()
    }

    this.update = this.update.bind(this);
    this.listGui = this.listGui.bind(this);
    this.startWatcher = this.startWatcher.bind(this);
  }

  componentDidMount (){
    DesignStore.on("design_loaded", this.update);
  }

  update(){
    this.setState({
      designs : DesignStore.getDesign()
    })
  }

  startWatcher () {
      this.timer = setInterval(function(){
      var iframe = document.getElementById('guidanceFrame');

      if(iframe){
        var innerDoc = iframe.contentDocument || iframe.contentWindow.document;
      }else{
        clearInterval(this.timer);
      }

       if(window.$(innerDoc).find("#guidance_success").length !== 0){
         clearInterval(this.timer);
         this.resetSelection();
       }
     }.bind(this), 1000)
  }

  resetSelection(){
    // this.state.ap =  null;
    // this.state.au =  null;
    // this.state.checkin =  null;
    // this.state.selection =  null;

    this.setState({
      ap:null,
      au:null,
      checkin:null,
      selection:null
    });

    CheckinStore.guidanceDone();
  }

  singleGui(){
    let baseURL = properties.guidance;
    let tokenPart ="?SID=" + properties.key;
    let params ="&gui_id=9&action=start_guide&jau_id=" +
    this.state.checkin.au.au_jau_id + "&gui_id=" + this.state.selection.gui_id +
    "&ap_id=" + this.state.checkin.ap.ap_id + "&au_id="  + this.state.checkin.au.au_id;
    let iframeURL = baseURL + tokenPart + params;
    this.startWatcher();

    return (
      <div id="guidance">
        <h1>{LanguageStore.translate("checkin_guidance")}</h1>
        <Iframe url={iframeURL}
        width="450px"
        height="450px"
        id="guidanceFrame"
        className="myClassname"
        display="initial"
        position="relative"/>
      </div>
    );
  }

  guiSelected(e, item){
    this.state.checkin.guidance = this.state.checkin.guidance.filter(function(value, index, arr){
      return value.gui_id !== item.gui_id;
    });
    this.setState({
      selection : item
    });
  }

  listGui(){
    let buttonStyles = null

    if(this.state.designs){
      buttonStyles = {
        backgroundColor:this.state.designs["main_color"]
      };
    }

    return (
      <div className="guidance_list">
      <h1>{LanguageStore.translate("checkin_guidance_missing")}</h1>
        <ul>
          {this.state.checkin.guidance.map(function(gui, index){
            return <li className="button btn-guid" style={buttonStyles} onClick={(e) => this.guiSelected(e, gui)} key={ index }>{gui.gui_name}</li>;
          }.bind(this))}
        </ul>
      </div>
    )
  }

  render() {
    if(this.state.checkin === null){
      this.state.checkin= CheckinStore.getCheckin()
    }

    let content = (<div></div>);

    if(this.state.selection !== null){
      content = this.singleGui();
    }else{
      content = this.listGui();
    }

    return(
      content
    )
  }
}

export default Guidance;
