import React from 'react';
import Iframe from 'react-iframe'
import { properties } from '../../../properties.js';
import CheckinStore from "./../../../stores/CheckinStore";
import LanguageStore from "./../../../stores/LanguageStore";

class Guidance extends React.Component {

  constructor(props){
    super(props)
    this.state ={
      ap : props.checkin.ap,
      au : props.checkin.au,
      checkin : props.checkin,
    }
  }

  componentDidMount () {
    var timer = setInterval(function(){
       var iframe = document.getElementById('guidanceFrame');
       var innerDoc = iframe.contentDocument || iframe.contentWindow.document;

       if(window.$(innerDoc).find("#guidance_success").length !== 0){
         clearInterval(timer);
         setTimeout(function(){
           CheckinStore.guidanceDone();
         },2000)
       }
     }, 1000)
  }

  render() {
    let baseURL = properties.guidance;
    let tokenPart ="?SID=" + properties.api_token;
    let params ="&gui_id=9&action=start_guide&jau_id=123&gui_id=9&ap_id=1290&au_id=1198";
    let iframeURL = baseURL + tokenPart + params;
    return (
      <div id="guidance">
        <h1>{LanguageStore.translate("checkin_guidance")}</h1>
        <Iframe url={iframeURL}
        width="450px"
        height="450px"
        id="guidanceFrame"
        className="myClassname"
        display="initial"
        position="relative"/>
      </div>
    );
  }
}

export default Guidance;
