import React from 'react';
import QrReader from 'react-qr-reader'
import axios from 'axios';
import Greeting from "./Greeting";
import { properties } from '../../../properties.js';
import AppStore from "./../../../stores/AppStore";
import LanguageStore from "./../../../stores/LanguageStore";

class QRScan extends React.Component {

  constructor(props) {
    super(props);

    this.state = {
      display: AppStore.getDisplay(),
      ap: null,
      au: null,
    }

    this.handleScan = this.handleScan.bind(this);
    this.update = this.update.bind(this);
    this.hwqr_code_scanned = this.hwqr_code_scanned.bind(this);
    this.focusSaver = null;
  }

    componentDidMount (){
      AppStore.load();
      AppStore.on("loaded", this.update);
    }

    update(){
      this.setState({
        display : AppStore.getDisplay(),
      })
    }

    hwqr_code_scanned(event){
      event.preventDefault();
      clearInterval(this.focusSaver);
      var code = window.$('#hw_qr_code').val();
      window.$('#hw_qr_code').val("");
      this.handleScan(code);
    }

    handleScan = function(data) {
      if (data) {
        axios.get(properties.api_url + "/visitors/?qrcode="+data+"&SID=" + properties.key,{code:data})
         .then(res => {
           this.setState({
             ap: res.data.AP,
             au: res.data.AU
           })
         }).catch(function(e){
           axios.get(properties.api_url + "/door/?code="+data+"&SID=" + properties.key,{code:data})
           .then(function(){
             setTimeout(function(){
               window.location.reload();
             }, 1000 * 3);

             this.setState({
               open_action : "success"
             });

           }.bind(this)).catch(this.error)
         }.bind(this));
      }
    }

    handleError = err => {
      console.error(err)
    }

  render() {

    if(this.state.open_action === "success"){
      return(
        <div className="main_view" id="entry">
          <h1>Eingabe erfolgreich - Tür öffnet</h1>
        </div>
      );
    }

    if(!this.state.display){
        return (<div>loading ... </div>);
    }

    let content ="";
    if(this.state.ap == null){
      if(this.state.display.di_qr_engine === "js"){
        content =(
          <div className="QRScan">
            <h1>{LanguageStore.translate("checkin_scan")}</h1>
            <QrReader
              className="QRCode_reader"
              delay={1}
              onError={this.handleError}
              onScan={this.handleScan}
            />
          </div>
        )
      }else{

        this.focusSaver = setInterval(function(){
          window.$("#hw_qr_code").focus();
        }, 100);

        content =(
          <div className="QRScan">
            <h1>{LanguageStore.translate("checkin_scan")}</h1>
            <div className="img_wrapper"><img src="/img/animation_qr.gif" alt="animation" /></div>
            <form onSubmit={this.hwqr_code_scanned}>
              <input id="hw_qr_code" type="text" className="hw_qr_input" autoFocus  />
            </form>
          </div>
        )
      }
    }else{
      content = ( <Greeting ap={this.state.ap} au={this.state.au} /> )
    }
    return (
      <div id="QRCode" className="main_view">
        {content}
      </div>
    );
  }
}

export default QRScan;
