import React from 'react';
import axios from 'axios';
import dispatcher from "../../../Dispatcher";
import { properties } from '../../../properties.js';
import AppStore from "./../../../stores/AppStore";

class Sites extends React.Component {

  constructor(props) {
    super(props);

    this.state = {
      display: AppStore.getDisplay(),
      sites: [],
    }
  }

  componentDidMount (){
    this.loadsites();
  }

  loadsites(){
    axios.get(properties.api_url + "/site/?SID=" + properties.key)
    .then(res => {
      this.setState({
        sites: res.data,
        })
      })
  }

  changeLanguage(id){

    window.globals["site_id"] = id;

    dispatcher.dispatch({
      type: "update_action",
      data: "main"
    })
  }

  render() {
    const sites = this.state.sites.map((site) =>
      <div key={site.site_id} className="single_site" id={site.site_id} onClick={(e) => this.changeLanguage(site.site_id)} >
        <img className="single_site_img" src={properties.images_url + site.site_descr} alt={site.site_name} />
      </div>
    );

    return (
      <div id="sites" className="main_view">
        {sites}
      </div>
    );
  }
}

export default Sites;
