import React from 'react';
import DesignStore from "./../../stores/DesignStore";
import AppStore from "./../../stores/AppStore";

class Footer extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      time: new Date().toLocaleString(),
      display: []
    };
    this.update = this.update.bind(this);
  }

  componentDidMount() {
    DesignStore.on("design_loaded", this.update);
    AppStore.on("loaded", this.update);
    this.intervalID = setInterval(
      () => this.tick(),
      1000
    );
  }

  update(){
    this.setState({
      designs : DesignStore.getDesign(),
      display : AppStore.getDisplay()
    })
  }

  componentWillUnmount() {
    clearInterval(this.intervalID);
  }

  tick() {
    this.setState({
      time: new Date().toLocaleString()
    });
  }

  render() {
    let stylesTime = null
    let stylesLocation = null
    let stylesfooter = null

    if(this.state.designs){
      stylesTime = {
        display:this.state.designs["show_location"],
        color:this.state.designs["bot_font_color"],
      };
      stylesLocation = {
        display:this.state.designs["show_time"],
        color:this.state.designs["bot_font_color"],
      };

      stylesfooter = {
        backgroundColor:this.state.designs["bot_bg_color"],
      };
    }

    return (
        <div id="footer_wrapper" style={stylesfooter}>
          <span  style={stylesTime} className="time">{this.state.time}</span>
          <span  style={stylesLocation} className="location">{this.state.display.di_loc_name}</span>
        </div>
    );
  }
}

export default Footer;
