import React from 'react';
import DesignStore from "./../../stores/DesignStore";
import DynSVG from "./../UI/DynSVG";

class Header extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      designs : DesignStore.getDesign()
    };

    this.update = this.update.bind(this);
    }

  componentDidMount (){
    DesignStore.on("design_loaded", this.update);
    // AppStore.on("change_action", this.changeAction);
  }

  update(){
    this.setState({
      designs : DesignStore.getDesign()
    })
  }

  render() {
    let styles = null
    let logo = null
    let title =""
    if(this.state.designs){
      styles = {
        color: this.state.designs["top_font_color"],
      };
      logo = "/portals/download.php?mode=dl_media_file&me_id=" + this.state.designs["logo"]
      title = this.state.designs["title"]
    }

    return (
      <div className="header" >
        <img data-link="home" src={logo} alt="logo" />
        <span className="title" style={styles}>{title}</span>
        <div id="backbutton">
          <DynSVG src="/img/icons/home.svg" action={window.globals.home} text="Zurück" />
        </div>
      </div>
    );
  }
}

export default Header;
