import React from 'react';
import {Brick} from '../../../src/components';
import DesignStore from "./../../stores/DesignStore";
import {Elements} from "./Bricklist";


class Menu extends React.Component {

  constructor(props) {
  super(props);
    this.state = {
      clickHandler : props.handler,
      display:props.display,
      designs : DesignStore.getDesign(),
    };
    this.update = this.update.bind(this);
    this.filterMenu = this.filterMenu.bind(this);
  }

  componentDidMount (){
    DesignStore.on("design_loaded", this.update);
  }

  filterMenu(value) {
    return this.state.designs[value.ms_id] && this.state.designs[value.ms_id] === "on"
  }

  update(){
    this.setState({
      designs : DesignStore.getDesign()
    })
  }

  render() {
    let result = []
    if(this.state.designs){
      result = Elements.filter( this.filterMenu );
    }else{
      return(<div></div>)
    }

    return (
      <div className="action" id="menu_wrapper">

      {result.map((element, i) => {

        return (
          <Brick
            key = {i}
            icon = {element.icon}
            desc = {element.desc}
            button = {element.button}
            title = {element.title}
            link = {element.link}
            handler = {this.state.clickHandler} />
          )
        })}

      </div>
    );
  }
}

export default Menu;
