import React from 'react';
import PDFElement from './PDFElement'
import axios from 'axios';
import { properties } from '../../properties.js';

class Slider extends React.Component {

  constructor(props, context) {
     super(props, context);
     const queryString = require('query-string');
     const parsed = queryString.parse(window.location.search);

     this.state = {
       displayId:parsed.di_id,
       medias:[],
       intervalId:0,
       index:0,
       interval: 5000
     };

     this.handleSelect = this.handleSelect.bind(this);
     this.startnterval = this.startnterval.bind(this);
     this.stopInterval = this.stopInterval.bind(this);
     this.pdfEnds = this.pdfEnds.bind(this);
   }

   loadSlider(){
     axios({
         method: 'get',
         url: properties.api_url + "/display/" + this.state.displayId + "/slider/?SID=" + properties.key,
       })
       .then(res => {
         this.setState({
           medias:res.data
         });
       }).catch(function (error) {
         console.log(error);
         var error_str = "<div className='e'>" + error.message + " <br> "
          error_str += error.request.responseURL+ " </div>"
         window.$("#error_message").append(error_str);
       })
   }

   componentDidMount() {
     this.loadSlider();
     this.startnterval();
    }

    componentWillUnmount() {
      this.stopInterval();
     }

    handleSelect(){
      this.setState({index: (this.state.index + 1) % this.state.medias.length });
    }

    stopInterval(){
      clearInterval(this.state.intervalId)
    }

    startnterval(){
      var intervalId = setInterval(this.handleSelect, this.state.interval);
      this.setState({intervalId: intervalId});
    }

    pdfEnds(){
      this.handleSelect();
      this.startnterval();
    }

  render() {
    const { index } = this.state;
    let slider = this.state.medias[index];
    let element = <div />;
    let type = "";
    if(slider){

      element =<div>{slider.me_type}</div>

      switch (slider.me_type) {
        case "png":
        case "jpg":
          var url = slider.download;
          element=<img alt="SliderImage" className="slider_img" src={url} />
          break;
        case "pdf":
          element = <PDFElement className="slider_img" src={slider} callback={this.pdfEnds} interval={this.state.interval}/>
          this.stopInterval();
        break;
        default:
        console.log(slider.me_type);
        break;
      }
    }

    return (
      <div className="slider">
        {element}
      </div>
    );
}
}

export default Slider;
