import dispatcher from "../Dispatcher";
import {EventEmitter} from "events";
import axios from 'axios';
import { properties } from '../properties.js';

class AppStore extends EventEmitter {

    constructor() {
        super();
        const queryString = require('query-string');
        const parsed = queryString.parse(window.location.search);
        this.action = "";
        this.display = {
          di_id:parsed.di_id,
          features:[
            {df_name:"QRScan", df_id:"1"},
            {df_name:"ContactSearch", df_id:"2"},
            {df_name:"Language", df_id:"3"},
            {df_name:"Location", df_id:"4"},
          ]
        };
        this.load = this.load.bind(this);
        this.load();
    }

    handleActions(action) {
      switch (action.type) {
          case "update_action": {
            this.action = action.data;
            this.emit("change_action");
            break;
          }

          default: {
          }
      }
    }

    load(){
      axios.get(properties.api_url + "/display/" + this.display.di_id + "?SID=" + properties.key)
        .then(res => {
          const designs = res.data;
          this.display = designs;
          this.emit("loaded");
        }).catch(function (error) {
          var error_str = "<div className='e'>" + error.message + " <br> "
           error_str += error.request.responseURL+ " </div>"
          window.$("#error_message").append(error_str);
          console.log(error);
        })
    }

    getAction() {
        return this.action;
    }

    getDisplay() {
        return this.display;
    }
}

const appStore = new AppStore();
dispatcher.register(appStore.handleActions.bind(appStore));
export default appStore;
