import dispatcher from "../Dispatcher";
import {EventEmitter} from "events";
import axios from 'axios';
import { properties } from '../properties.js';

class CheckOutStore extends EventEmitter {

    constructor() {
        super();
        const queryString = require('query-string');
        const parsed = queryString.parse(window.location.search);

        this.status = "";
        this.display = { di_id:parsed.di_id, };
        this.checklist = [];
        this.init = this.init.bind(this);
        this.checkOut = this.checkOut.bind(this);
        this.handleCheckOutFail = this.handleCheckOutFail.bind(this);
        this.calcStatus = this.calcStatus.bind(this);
        this.sendCheckOutList = this.sendCheckOutList.bind(this);
        this.checkOutResult = null;

        this.au_id = null;
    }

    sendCheckOutList(data){
      var url = properties.api_url + "/checklist_leave/?SID=" + properties.key;
      axios.post(url, data)
        .then(this.checkOut).catch(function (error) {
          var error_str = "<div className='e'>" + error.message + " <br> "
           error_str += error.request.responseURL+ " </div>"
          window.$("#error_message").append(error_str);
          console.log(error);
        })
    }

    init(au_id){
      this.au_id = au_id;
      this.checkOutResult = null;
      this.checkOut();
    }

    getCheckOutlist(){
      return this.checklist;
    }

    loadCheckOutlist(id){
      console.log(this.checkOutResult)
      axios.get(properties.api_url + "/checklist/" + this.checkOutResult.ap.ap_checklist_leave + "?SID=" + properties.key)
        .then(res => {
          this.checklist  = res.data;
          this.emit("checkOutList_loaded");
        }).catch(function (error) {
          var error_str = "<div className='e'>" + error.message + " <br> "
           error_str += error.request.responseURL+ " </div>"
          window.$("#error_message").append(error_str);
          console.log(error);
        })
    }

    handleCheckOutFail(error){
      this.checkOutResult =  error.response.data
      this.calcStatus();

      this.emit("checkOut_loaded");
    }

    calcStatus(){
      if(this.checkOutResult === null ||
        this.checkOutResult === undefined ||
        this.checkOutResult.au === null ||
         this.checkOutResult.au === undefined){
           console.log("checkOutResult ???");
        return;
      }

      if( this.checkOutResult && this.checkOutResult.success === true ){

        this.status = "bye"

      }else{

        if( (this.checkOutResult.ap.ap_checklist_leave !== "" && this.checkOutResult.ap.ap_checklist_leave !== "-1" && this.checkOutResult.ap.ap_checklist_leave !== null )
         && (this.checkOutResult.au.au_checklist_leave_done === null || this.checkOutResult.au.au_checklist_leave_done !== "1" ) ){

          this.status = "checkOutlist"

        }else{
            console.log("???");
        }

      }

      this.emit("checkOut_changed");
    }

    checkOut(){
      this.checkOutResult = null;
      axios.get(properties.api_url + "/visitor/"+this.au_id + "/checkout/?SID=" + properties.key)
        .then(res => {
          this.checkOutResult = res.data;
          this.calcStatus();
          this.emit("checkout_loaded");
        }).catch(this.handleCheckOutFail)
    }

    getCheckOut(){
      return this.checkOutResult;
    }

    getStatus() {
      return this.status;
    }

    handleActions(){}
}

const checkoutStore = new CheckOutStore();
dispatcher.register(checkoutStore.handleActions.bind(checkoutStore));
export default checkoutStore;
