import dispatcher from "../Dispatcher";
import {EventEmitter} from "events";
import axios from 'axios';
import { properties } from '../properties.js';

class HostStore extends EventEmitter {

    constructor() {
        super();

        this.loadHosts = this.loadHosts.bind(this);
        this.getHosts = this.getHosts.bind(this);
        this.hosts = [];
    }

    getHosts(){
      return this.hosts;
    }

    loadHosts(){
      var url = properties.api_url + "/hosts/?SID=" + properties.key;
      axios.get(url)
        .then(res => {
          let datas = res.data;
          this.hosts = datas;

          this.emit("hosts_loaded");

        }).catch(function (error) {
          var error_str = "<div className='e'>" + error.message + " <br> "
           error_str += error.request.responseURL+ " </div>"
          window.$("#error_message").append(error_str);
          console.log(error);
        })
    }

    handleActions(action) {}

}



const host = new HostStore();
dispatcher.register(host.handleActions.bind(host));
export default host;
